package eu.mhsl.craftattack.worldmuseum.commands;

import net.minestom.server.command.builder.Command;
import net.minestom.server.command.builder.arguments.ArgumentType;
import net.minestom.server.coordinate.Pos;
import net.minestom.server.entity.Player;
import java.util.Objects;

public class TeleportCommand extends Command {

    public TeleportCommand() {
        super("tp");

        var coordinate = ArgumentType.RelativeBlockPosition("cords");
        addSyntax(((sender, context) -> {
            Pos pos = context.get(coordinate).fromSender(sender).asPosition();
            Player player = (Player) sender;
            player.teleport(pos);
        }), coordinate);

        var playerArgument = ArgumentType.Entity("player").onlyPlayers(true).singleEntity(true);
        addSyntax(((sender, context) -> {
            if (context.get(playerArgument).find(sender).isEmpty()) return; //check if player is online
            Player targetPlayer = (Player) context.get(playerArgument).find(sender).get(0);
            Player p = (Player) sender;
            if (!Objects.equals(p.getInstance(), targetPlayer.getInstance())) {
                p.setInstance(Objects.requireNonNull(targetPlayer.getInstance()), targetPlayer.getPosition());
            } else {
                p.teleport(targetPlayer.getPosition());
            }
        }), playerArgument);
    }
}
