package eu.mhsl.craftattack.worldmuseum.items;

import eu.mhsl.craftattack.worldmuseum.util.MuseumPlayer;
import net.minestom.server.entity.Player;
import net.minestom.server.item.ItemStack;
import net.minestom.server.tag.Tag;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.function.Consumer;

public class ActionItem {
    public static Tag<UUID> tag = Tag.UUID("action");
    public static Map<UUID, Consumer<MuseumPlayer>> actions = new HashMap<>();

    private final ItemStack itemStack;

    public ActionItem(Consumer<MuseumPlayer> action, ItemStack itemStack) {
        UUID uuid = UUID.randomUUID();
        this.itemStack = itemStack.withTag(tag, uuid);
        actions.put(uuid, action);
    }

    public static void run(UUID uuid, Player p) {
        actions.get(uuid).accept((MuseumPlayer) p);
    }

    public ItemStack getItemStack() {
        return itemStack;
    }
}
