package eu.mhsl.craftattack.worldmuseum.items;

import eu.mhsl.craftattack.worldmuseum.commands.SpawnCommand;
import eu.mhsl.craftattack.worldmuseum.util.MuseumPlayer;
import eu.mhsl.craftattack.worldmuseum.worlds.VoidWorld;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.format.NamedTextColor;
import net.minestom.server.item.ItemStack;
import net.minestom.server.item.Material;

import java.util.function.Consumer;

public enum Items {
    HUB(
            ItemStack
                    .of(Material.IRON_DOOR)
                    .withDisplayName(
                            Component
                                    .text("Zurück zur Überischt")
                                    .color(NamedTextColor.GOLD)
                    ),
            player -> new VoidWorld().movePlayer(player)
    ),

    SPAWN(
            ItemStack
                    .of(Material.TARGET)
                    .withDisplayName(
                            Component
                                    .text("Zum Spawn")
                                    .color(NamedTextColor.GOLD)
                    ),
            SpawnCommand::teleportToSpawn
    ),

    MORE_SPEED(
            ItemStack
                    .of(Material.FEATHER)
                    .withDisplayName(
                            Component
                                    .text("Schneller fliegen")
                                    .color(NamedTextColor.AQUA)
                    ),
            player -> player.updateFlyingSpeed(0.05f)
    ),

    LESS_SPEED(
            ItemStack
                    .of(Material.ANVIL)
                    .withDisplayName(
                            Component
                                    .text("Langsamer fliegen")
                                    .color(NamedTextColor.AQUA)
                    ),
            player -> player.updateFlyingSpeed(-0.05f)
    );


    private final ActionItem item;
    Items(ItemStack itemStack, Consumer<MuseumPlayer> action) {
        item = new ActionItem(action, itemStack);
    }

    public ItemStack getItem() {
        return item.getItemStack();
    }
}
