package eu.mhsl.craftattack.worldmuseum.util;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Config {
    private static Config instance;
    private boolean bungeecordEnabled = false;
    private String bungeeReturnServerName;
    public static Config getInstance() {
        if (instance == null) instance = new Config();
        return instance;
    }
    public void loadConfig() {
        createDefaultIfNotExists();
        try {
            JsonObject config = (JsonObject) JsonParser.parseReader(new FileReader("config.json"));
            this.bungeecordEnabled = config.get("bungeecord").getAsBoolean();
            this.bungeeReturnServerName = config.get("bc-return-servername").getAsString();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private void createDefaultIfNotExists() {
        try {
            File checkfile = new File("./config.json");
            if (checkfile.createNewFile()) {
                FileWriter fileWriter = new FileWriter("config.json");
                String default_config = """
                        {
                          "bc-return-servername": "server",
                          "bungeecord": false
                        }""";
                fileWriter.write(default_config);
                fileWriter.close();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public boolean isBungeecordEnabled() {
        return bungeecordEnabled;
    }

    public String getBungeeReturnServerName() {
        return bungeeReturnServerName;
    }
}
