package eu.mhsl.craftattack.worldmuseum.worlds;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class WorldManager {
    private static WorldManager instance;
    private final List<World> worlds = new ArrayList<>();

    public static WorldManager getInstance() {
        if (instance == null) {
            instance = new WorldManager();
        }
        return instance;
    }
    public void loadWorlds() throws IOException {
        File saveDirectory = new File("saves");
        if(!saveDirectory.exists()) throw new IOException("Saves folder 'saves' could not be found!");
        List<File> worldFolders = getFolders(saveDirectory);
        for (File f : worldFolders) {
            World w = new World(f);
            if (w.isEnabled()) {
                worlds.add(w);
            } else {
                System.out.println("Es gibt eine nicht aktivierte Welt: " + f);
            }
        }

    }

    private List<File> getFolders(File directory) {
        File[] fileList = directory.listFiles();
        if(fileList == null) return new ArrayList<>();

        return Arrays.stream(fileList).filter(File::isDirectory).toList();
    }

    public List<World> getWorlds() {
        return worlds;
    }
}
